
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <time.h>


#include "COM.h"


char GPGGA[] = "$GPGGA,000000.000,4333.0000,N,01019.0000,E,1,09,1.0,10.0,M,50.0,M*??\r\n";

unsigned char checksum(char string[], int n)
{
 int i;
 unsigned char crc = 0x00;

 for (i=0; i<n; i++)
    crc = crc ^ string[i];
 
 return crc;
}

void set_time(char gpgga[], unsigned int sec)
{
 char hms[7];

 sprintf(&hms[0], "%02d", (sec/3600));
 sprintf(&hms[2], "%02d", ((sec%3600)/60));
 sprintf(&hms[4], "%02d", (sec%60));
 memcpy(&gpgga[7], hms, 6);
}


int main(void)
{
 HANDLE com;
 unsigned char crc;
 char hex[3];
 unsigned long start, now;

 com = COM_open(1, 1, 4800, 'n', 8, 1, 0);
 if ((long)com <= 0)
   {
    printf("Errore apertura porta seriale!\r\n");
    return -1;
   }

 start = (unsigned long)time(NULL);

 for (;;)
    {
     Sleep(1000);
     now = (unsigned long)time(NULL) - start;
     set_time(GPGGA, now);
     crc = checksum(&GPGGA[1], 64);
     sprintf(hex, "%02X", crc);
     GPGGA[66] = hex[0];
     GPGGA[67] = hex[1];
     COM_write(com, (unsigned char*)GPGGA, strlen(GPGGA));
     printf("%s\r\n", GPGGA);
    }
}

